use gtk4 as gtk;

use crate::{model::models::*, model_utils::hamming_code_seven_four::*};
use gtk::{prelude::*, *};

pub fn start_hamming_algorithm(input: &TextView, output: &TextView, mode: bool) {
    let (iter_start, iter_end) = input.buffer().bounds();
    let parsed_input: String = input
        .buffer()
        .text(&iter_start, &iter_end, false)
        .to_string()
        .trim()
        .parse()
        .unwrap();

    let operation = if mode {
        HammingMode::Encrypt
    } else {
        HammingMode::Decrypt
    };

    match hamming(parsed_input, operation) {
        Ok(res) => output.buffer().set_text(res.trim_end()),
        Err(rej) => output.buffer().set_text(rej.as_str()),
    }
}

pub fn check_correct_binary_code(
    input: &String,
    prepared_input: &String,
    l: usize,
) -> (bool, bool) {
    let first_condition: bool = input
        .as_str()
        .chars()
        .all(|c| c == '1' || c == '0' || c == ' ');

    let second_condition: bool = prepared_input.len() % l == 0;

    (first_condition, second_condition)
}
